'
'  CSV To EXCEL Ro[g (UTF-8p)
'    ENbNj[CSVt@C𐮌`ExcelŊJ
'      author  :  zumu zack
'      update  :  2022/04/18
'
Option Explicit

'On Error Resume Next

Const C_Excel_FONT_SIZE = 9           '  ExceltHgTCY 
Const C_DISP_GRIDLINE = False         '  ExcelObh

Const C_LINK_NAME = "_CsvToExcel_UTF8"
Const C_CHAR_CODE = "UTF-8"           ' 

Dim objFileSys
Dim sScriptId
Dim lngPos

' JgfBNg擾
Dim strCurPath
Dim iDiffLen
iDiffLen = Len(WScript.ScriptFullName) - Len(WScript.ScriptName)
strCurPath = Left(WScript.ScriptFullName, iDiffLen)

Set objFileSys = WScript.CreateObject("Scripting.FileSystemObject")

' XNvg擾
lngPos = InStrRev(WScript.ScriptName, ".")
sScriptId = Mid(WScript.ScriptName, 1, lngPos - 1)

If WScript.Arguments.Count = 0 Then
    ' Ȃ̏ꍇ́ACXg[/ACXg[{ -----------------------------------
    Call sendToOnOff(sScriptId, C_LINK_NAME)
    WScript.Quit
End If

' CSV > EXCEL  --------------------------------------------------------------------------

Dim udtFiles()
Dim nIdx

Class typFile
    Public sFilePath
    Public sFileName
    Public sSheetName
    Public bModName
End Class

Dim sArg
nIdx = 0
For Each sArg In WScript.Arguments
    Redim Preserve udtFiles(nIdx)
    Set udtFiles(nIdx) = New typFile
    udtFiles(nIdx).sFilePath = sArg
    udtFiles(nIdx).sFileName = objFileSys.GetFileName(sArg)
    If Len(udtFiles(nIdx).sFileName) > 30 Then
        udtFiles(nIdx).sSheetName = Mid(udtFiles(nIdx).sFileName, 1, 30)
    Else
        udtFiles(nIdx).sSheetName = udtFiles(nIdx).sFileName
    End If
    udtFiles(nIdx).bModName = False
    nIdx = nIdx + 1
Next

Dim nFindIdx
Dim nSheetIdx

For nIdx = 0 To UBound(udtFiles)
    If udtFiles(nIdx).sFileName <> udtFiles(nIdx).sSheetName Then
        nSheetIdx = 1
        For nFindIdx = nIdx + 1 To UBound(udtFiles)
            If Not udtFiles(nIdx).bModName Then
                If udtFiles(nIdx).sSheetName = udtFiles(nFindIdx).sSheetName Then
                    ' V[g -> ioO
                    nSheetIdx = nSheetIdx + 1
                    If Len(CStr(nSheetIdx)) > 1 Then
                        udtFiles(nFindIdx).sSheetName = Mid(udtFiles(nIdx).sSheetName, 1, 27) & "~" & CStr(nSheetIdx)
                    Else
                        udtFiles(nFindIdx).sSheetName = Mid(udtFiles(nIdx).sSheetName, 1, 28) & "~" & CStr(nSheetIdx)
                    End If
                End If
            End If
        Next
    Else
        udtFiles(nIdx).bModName = True
    End If
Next

Dim objFileInfo
Set objFileInfo = New typFile

Dim nMaxCol        ' CSVő
Dim nColW
Dim sPastArray()   ' CSVf[^ޔpz    a()()`
Dim arrPastData()  ' ExcelZbgpz      a(,)`       -- ̌`łȂ ExcelɃZbgłȂۂ(IƂ͂A1ڂ 1xݒłȂ)
Dim nLoop1
Dim nLoop2
Dim sRecord        ' CSVǂݍ݃R[h
Dim nPastInx       ' sPastArray()pCfbNX
Dim objCsvFile
Dim strArgFileName ' CSVt@C

nMaxCol = 1

Dim blnSw
Dim objXlsApp
Set objXlsApp = CreateObject("Excel.Application")
objXlsApp.Application.Visible = False

objXlsApp.Application.Workbooks.Add()

blnSw = False

Dim arrRecord

For Each objFileInfo In udtFiles

    strArgFileName = objFileInfo.sFileName

    If LCase(objFileSys.GetExtensionName(strArgFileName)) = "csv" _
    Or LCase(objFileSys.GetExtensionName(strArgFileName)) = "txt" _
    Or LCase(objFileSys.GetExtensionName(strArgFileName)) = "log" Then

        ' CSVǂݍ݃p[^
        Set objCsvFile = CreateObject("ADODB.Stream")
        objCsvFile.Open
        objCsvFile.Type = 2
        objCsvFile.Charset = C_CHAR_CODE
        objCsvFile.LoadFromFile = objFileInfo.sFilePath

        ' CSVǂݍ&ޔ
        sRecord = objCsvFile.ReadText
        ' sR[h&
        If InStr(sRecord, vbCrlf) > 0 Then
            arrRecord = split(sRecord, vbCrlf)
        ElseIf InStr(sRecord, vbLf) > 0 Then
            arrRecord = split(sRecord, vbLf)
        ElseIf InStr(sRecord, vbCr) > 0 Then
            arrRecord = split(sRecord, vbCr)
        Else
            arrRecord = split(sRecord, "")
        End If
        nPastInx = 0

        For nLoop1 = 0 To UBound(arrRecord)

            Redim Preserve sPastArray(nPastInx)
            sPastArray(nPastInx) = split(arrRecord(nLoop1), ",")
            nColW = UBound(sPastArray(nPastInx))
            ' őJo
            If nMaxCol < nColW  Then
                nMaxCol = nColW
            End If
            nPastInx = nPastInx + 1
        Next

        ' sPastArray()()  arrPastData(,) lߑւ
        Redim arrPastData(UBound(sPastArray), nMaxCol)
        For nLoop1 = 0 To UBound(sPastArray)
            For nLoop2 = 0 To UBound(sPastArray(nLoop1))
                arrPastData(nLoop1, nLoop2) = sPastArray(nLoop1)(nLoop2)
            Next
        Next

        ' CSVt@CN[Y
        objCsvFile.Close
        Set objCsvFile = Nothing

        ' EXCELҏW
        objXlsApp.ActiveSheet.Name = objFileSys.GetFileName(objFileInfo.sSheetName)          ' V[g = CSVt@C
        objXlsApp.ActiveSheet.Range("A1").Value = objFileSys.GetFileName(strArgFileName)     ' "A1"ZCSVt@C \

        ' V[gS̃vpeB
        objXlsApp.ActiveSheet.Cells.Select
        objXlsApp.Selection.NumberFormatLocal = "@"            ' Z^:
        With objXlsApp.Selection.Font
            .Size = C_Excel_FONT_SIZE                          ' tHgTCY
        End With
        objXlsApp.Selection.ColumnWidth = 2                    ' IZ:2

        ' CSVzf[^Zbg(Rangeɔẑ܂܃ZbgԂȂ)
        With objXlsApp.ActiveSheet
        .Range(.Cells(2,2), .Cells(UBound(sPastArray) + 2, nMaxCol + 2)) = arrPastData
        End With

        ' EXCELV[g̍ق𐮂
        objXlsApp.ActiveSheet.Cells.EntireColumn.AutoFit       ' IZ:Fit
        objXlsApp.ActiveSheet.Range("A1").Select
        objXlsApp.Selection.ColumnWidth = 2                    ' A:2
        objXlsApp.ActiveWindow.DisplayGridlines = C_DISP_GRIDLINE        ' Obh

        objXlsApp.Application.WorkSheets.Add ,objXlsApp.Worksheets(objXlsApp.Worksheets.Count)     ' V[gǉ(CSVt@CIp)

        blnSw = True

    End If

Next

If blnSw Then
    objXlsApp.ActiveSheet.Delete         ' V[g폜
    objXlsApp.Worksheets(1).Activate     ' 擪V[gANeBu
    objXlsApp.Application.Visible = True
Else
    objXlsApp.Quit
    Msgbox "It@CCSVt@Cł͂܂", vbCritical, sScriptId
End If

Set objXlsApp = Nothing
Set objFileSys = Nothing

If Err.Number <> 0 Then
    Msgbox CStr(Err.Number) & ":" & Err.Description, vbCritical, sScriptId
End If

WScript.Quit


' SendTo o^/ (2020/03/21) --------------------------------------------------------------------
'   iScriptId:XNvgId.AiSendTitle:N^Cg(郁j[)
'   
Function sendToOnOff(iScriptId, iSendTitle)

    Const C_EXT_LINK = ".lnk"
    Const C_SENDTO = "sendto"

    Dim objShell     ' DOSR}h
    Dim objFileSys   ' t@CVXe
    Dim objLink      ' SendToN
    Dim sSendToPath  ' SnedTopX

    Set objShell = WScript.CreateObject("WScript.Shell")
    Set objFileSys = WScript.CreateObject("Scripting.FileSystemObject")

    ' ""tH_(SendTo)pX擾
    sSendToPath = objShell.SpecialFolders(C_SENDTO) & "\"

    If objFileSys.FileExists(sSendToPath & iSendTitle & C_EXT_LINK) Then
        If Msgbox(iScriptId & " ACXg[܂H", vbYesNo + vbQuestion, iScriptId & "ACXg[") = vbYes Then
            ' sendto烊N폜
            objFileSys.DeleteFile(sSendToPath & iSendTitle & C_EXT_LINK)
            If objFileSys.FileExists(sSendToPath & iSendTitle & C_EXT_LINK) Then
                Msgbox "ACXg[Ɏs܂", vbCritical, iScriptId & " ACXg["
            Else
                Msgbox iScriptId & " ACXg[܂" & vbCrlf & vbCrlf _
                & "@@( uvj[u" & iSendTitle & "v폜܂ )" _
                , vbInformation, iScriptId & " ACXg["
            End If
        End If
    Else
        If Msgbox(iScriptId & " CXg[܂H", vbYesNo + vbQuestion, iScriptId & " CXg[") = vbYes Then
            ' sendtoɃN𐶐
            Set objLink = objShell.CreateShortcut(sSendToPath & iSendTitle & C_EXT_LINK)
            objLink.TargetPath = strCurPath & WScript.ScriptName
            objLink.Save
            Set objLink = Nothing
            If objFileSys.FileExists(sSendToPath & iSendTitle & C_EXT_LINK) Then
                Msgbox iScriptId & " CXg[܂" & vbCrlf & vbCrlf _
                & "@@( uvj[Ɂu" & iSendTitle & "vǉ܂ )" _
                , vbInformation, iScriptId & " CXg["
            Else
                Msgbox "CXg[Ɏs܂", vbCritical, iScriptId & " CXg["
            End If
        End If
    End If

    Set objShell = Nothing
    Set objFileSys = Nothing

End Function
